      SUBROUTINE AFH5D(N,NV,A,D,E,E2)
         INTEGER N,NV
         DOUBLE PRECISION A,D,E,E2
         DIMENSION A(NV),D(N),E(N),E2(N)
         INTEGER I,II,IZ,J,JK,K,L
         DOUBLE PRECISION F,G,H,HH,SCALE,SYS056
         DATA SYS056/5.56268464627D-308/
C  I = N,1,-1
       DO 110 II = 1, N
          I = N + 1 - II
          L = I - 1
          IZ = (I*L)/2
          H = 0.D0
          SCALE = 0.0D0
          IF (L .LT. 1) GO TO 30
C  HOPM-KA CTPOK
             DO 10 K = 1, L
                IZ = IZ + 1
                D(K) = A(IZ)
                SCALE = SCALE + DABS(D(K))
   10        CONTINUE
             IF (SCALE .GT. SYS056) GO TO 40
                JK = IZ - L
                DO 20 K = 1, L
                   JK = JK + 1
                   A(JK) = 0.D0
   20           CONTINUE
                SCALE = 0.0D0
   30        CONTINUE
             E(I) = 0.0D0
             E2(I) = 0.0D0
             GO TO 100
   40     CONTINUE
          F = 1.D0/SCALE
          DO 50 K = 1, L
             D(K) = D(K)*F
             H = H + D(K)*D(K)
   50     CONTINUE
          E2(I) = SCALE*SCALE*H
          F = D(L)
          G = -DSIGN(DSQRT(H),F)
          E(I) = SCALE*G
          H = H - F*G
          D(L) = F - G
          A(IZ) = SCALE*D(L)
          IF (L .EQ. 1) GO TO 100
             F = 0.0D0
             DO 70 J = 1, L
                G = 0.D0
                JK = (J*(J - 1))/2
C  OPM-E  A*U
                DO 60 K = 1, L
                   JK = JK + 1
                   IF (K .GT. J) JK = JK + K - 2
                   G = G + A(JK)*D(K)
   60           CONTINUE
C  OPM-E BEKTOPA  A*U/H
                E(J) = G/H
                F = F + E(J)*D(J)
   70        CONTINUE
             HH = F/(H + H)
             JK = 0
C  PEOPAOBAHE MATP A
             DO 90 J = 1, L
                F = D(J)
                G = E(J) - HH*F
                E(J) = G
                DO 80 K = 1, J
                   JK = JK + 1
                   A(JK) = A(JK) - F*E(K) - G*D(K)
   80           CONTINUE
   90        CONTINUE
  100     CONTINUE
          D(I) = A(IZ+1)
          A(IZ+1) = SCALE*DSQRT(H)
  110  CONTINUE
       RETURN
      END
